﻿using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;
using System.ComponentModel;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        [EditorBrowsable(EditorBrowsableState.Never)]
        [Obsolete("Renamed to InvokeIfNonNull")]
        public static void InvokeOrNop(this Action action)
        {
            InvokeIfNonNull(action);
        }
        [EditorBrowsable(EditorBrowsableState.Never)]
        [Obsolete("Renamed to InvokeIfNonNull")]
        public static void InvokeOrNop<T>(this Action<T> action, T arg)
        {
            InvokeIfNonNull(action, arg);
        }
        [EditorBrowsable(EditorBrowsableState.Never)]
        [Obsolete("Renamed to InvokeIfNonNull")]
        public static void InvokeOrNop<T1, T2>(this Action<T1, T2> action, T1 arg1, T2 arg2)
        {
            InvokeIfNonNull(action, arg1, arg2);
        }
        [EditorBrowsable(EditorBrowsableState.Never)]
        [Obsolete("Renamed to InvokeIfNonNull")]
        public static void InvokeOrNop<T1, T2, T3>(this Action<T1, T2, T3> action, T1 arg1, T2 arg2, T3 arg3)
        {
            InvokeIfNonNull(action, arg1, arg2, arg3);
        }
        [EditorBrowsable(EditorBrowsableState.Never)]
        [Obsolete("Renamed to InvokeIfNonNull")]
        public static void InvokeOrNop<T1, T2, T3, T4>(this Action<T1, T2, T3, T4> action, T1 arg1, T2 arg2, T3 arg3, T4 arg4)
        {
            InvokeIfNonNull(action, arg1, arg2, arg3, arg4);
        }

        public static void InvokeIfNonNull(this Action action)
        {
            if (action == null) return;

            action();
        }
        public static void InvokeIfNonNull<T>(this Action<T> action, T arg)
        {
            if (action == null) return;

            action(arg);
        }
        public static void InvokeIfNonNull<T1, T2>(this Action<T1, T2> action, T1 arg1, T2 arg2)
        {
            if (action == null) return;

            action(arg1, arg2);
        }
        public static void InvokeIfNonNull<T1, T2, T3>(this Action<T1, T2, T3> action, T1 arg1, T2 arg2, T3 arg3)
        {
            if (action == null) return;

            action(arg1, arg2, arg3);
        }
        public static void InvokeIfNonNull<T1, T2, T3, T4>(this Action<T1, T2, T3, T4> action, T1 arg1, T2 arg2, T3 arg3, T4 arg4)
        {
            if (action == null) return;

            action(arg1, arg2, arg3, arg4);
        }
    }
}