﻿using System;
using System.Linq;
using System.Collections.Generic;

namespace Achiral
{
    using Achiral.Extension;
    public sealed partial class TupleList<T1, T2> : List<Tuple<T1, T2>>
    {
        public void Add(T1 item1, T2 item2)
        {
            this.Add(Make.Tuple(item1, item2));
        }
        public IEnumerable<TResult> Select<TResult>(Func<T1, T2, TResult> selector)
        {
            return this.Select(item => selector(item.Item1, item.Item2));
        }
    }

    public sealed partial class TupleList<T1, T2, T3> : List<Tuple<T1, T2, T3>>
    {
        public void Add(T1 item1, T2 item2, T3 item3)
        {
            this.Add(Make.Tuple(item1, item2, item3));
        }
        public IEnumerable<TResult> Select<TResult>(Func<T1, T2, T3, TResult> selector)
        {
            return this.Select(item => selector(item.Item1, item.Item2, item.Item3));
        }
    }

    public sealed partial class TupleList<T1, T2, T3, T4> : List<Tuple<T1, T2, T3, T4>>
    {
        public void Add(T1 item1, T2 item2, T3 item3, T4 item4)
        {
            this.Add(Make.Tuple(item1, item2, item3, item4));
        }
        public IEnumerable<TResult> Select<TResult>(Func<T1, T2, T3, T4, TResult> selector)
        {
            return this.Select(item => selector(item.Item1, item.Item2, item.Item3, item.Item4));
        }
    }
}